Loading...
Searching...
No Matches
juce::AudioProcessor Class Referenceabstract

## Detailed Description

Base class for audio processing classes or plugins.

This is intended to act as a base class of audio processor that is general enough to be wrapped as a VST, AU, AAX, etc, or used internally.

It is also used by the plugin hosting code as the wrapper around an instance of a loaded plugin.

You should derive your own class from this base class, and if you're building a plugin, you should implement a global function called createPluginFilter() which creates and returns a new instance of your subclass.

See also
  AAXClientExtensions, VST2ClientExtensions, VST3ClientExtensions

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/processors/juce_AudioProcessor.h

Inheritance diagram for juce::AudioProcessor:

## Classes

struct | BusesLayout
| Represents the bus layout state of a plug-in. More...
class | Bus
| Describes the layout and properties of an audio bus. More...
struct | CurveData
| Some plug-ins support sharing response curve data with the host so that it can display this curve on a console or in the mixer panel. More...
struct | TrackProperties
| A struct containing information about the DAW track inside which your AudioProcessor is loaded. More...
struct | BusProperties
| Structure used for AudioProcessor Callbacks. More...
struct | BusesProperties
| Structure used for AudioProcessor Callbacks. More...
class | ParameterChangeForwarder

## Public Types

enum | ProcessingPrecision { singlePrecision , doublePrecision }
enum class | Realtime { no , yes }
enum | WrapperType { wrapperType_Undefined = 0 , wrapperType_VST , wrapperType_VST3 , wrapperType_AudioUnit , wrapperType_AudioUnitv3 , wrapperType_AAX , wrapperType_Standalone , wrapperType_Unity , wrapperType_LV2 }
| Flags to indicate the type of plugin context in which a processor is being used. More...
using | ChangeDetails = AudioProcessorListener::ChangeDetails

## Public Member Functions

virtual | ~AudioProcessor ()
| Destructor.
virtual const String | getName () const =0
| Returns the name of this processor.
virtual StringArray | getAlternateDisplayNames () const
| Returns a list of alternative names to use for this processor.
virtual void | prepareToPlay (double sampleRate, int maximumExpectedSamplesPerBlock)=0
| Called before playback starts, to let the processor prepare itself.
virtual void | releaseResources ()=0
| Called after playback has stopped, to let the object free up any resources it no longer needs.
virtual void | memoryWarningReceived ()
| Called by the host to indicate that you should reduce your memory footprint.
virtual void | processBlock (AudioBuffer< float > &buffer, MidiBuffer &midiMessages)=0
| Renders the next block.
virtual void | processBlock (AudioBuffer< double > &buffer, MidiBuffer &midiMessages)
| Renders the next block.
virtual void | processBlockBypassed (AudioBuffer< float > &buffer, MidiBuffer &midiMessages)
| Renders the next block when the processor is being bypassed.
virtual void | processBlockBypassed (AudioBuffer< double > &buffer, MidiBuffer &midiMessages)
| Renders the next block when the processor is being bypassed.
int | getBusCount (bool isInput) const noexcept
| Returns the number of buses on the input or output side.
Bus * | getBus (bool isInput, int busIndex) noexcept
| Returns the audio bus with a given index and direction.
const Bus * | getBus (bool isInput, int busIndex) const noexcept
| Returns the audio bus with a given index and direction.
virtual bool | canAddBus (bool isInput) const
| Callback to query if a bus can currently be added.
virtual bool | canRemoveBus (bool isInput) const
| Callback to query if the last bus can currently be removed.
bool | addBus (bool isInput)
| Dynamically request an additional bus.
bool | removeBus (bool isInput)
| Dynamically remove the latest added bus.
bool | setBusesLayout (const BusesLayout &)
| Set the channel layouts of this audio processor.
bool | setBusesLayoutWithoutEnabling (const BusesLayout &)
| Set the channel layouts of this audio processor without changing the enablement state of the buses.
BusesLayout | getBusesLayout () const
| Provides the current channel layouts of this audio processor.
AudioChannelSet | getChannelLayoutOfBus (bool isInput, int busIndex) const noexcept
| Provides the channel layout of the bus with a given index and direction.
bool | setChannelLayoutOfBus (bool isInput, int busIndex, const AudioChannelSet &layout)
| Set the channel layout of the bus with a given index and direction.
int | getChannelCountOfBus (bool isInput, int busIndex) const noexcept
| Provides the number of channels of the bus with a given index and direction.
bool | enableAllBuses ()
| Enables all buses.
bool | disableNonMainBuses ()
| Disables all non-main buses (aux and sidechains).
int | getChannelIndexInProcessBlockBuffer (bool isInput, int busIndex, int channelIndex) const noexcept
| Returns the position of a bus's channels within the processBlock buffer.
int | getOffsetInBusBufferForAbsoluteChannelIndex (bool isInput, int absoluteChannelIndex, int &busIndex) const noexcept
| Returns the offset in a bus's buffer from an absolute channel index.
template<typename FloatType>
AudioBuffer< FloatType > | getBusBuffer (AudioBuffer< FloatType > &processBlockBuffer, bool isInput, int busIndex) const
| Returns an AudioBuffer containing a set of channel pointers for a specific bus.
bool | checkBusesLayoutSupported (const BusesLayout &) const
| Returns true if the Audio processor is likely to support a given layout.
virtual bool | supportsDoublePrecisionProcessing () const
| Returns true if the Audio processor supports double precision floating point processing.
ProcessingPrecision | getProcessingPrecision () const noexcept
| Returns the precision-mode of the processor.
bool | isUsingDoublePrecision () const noexcept
| Returns true if the current precision is set to doublePrecision.
void | setProcessingPrecision (ProcessingPrecision newPrecision) noexcept
| Changes the processing precision of the receiver.
AudioPlayHead * | getPlayHead () const noexcept
| Returns the current AudioPlayHead object that should be used to find out the state and position of the playhead.
int | getTotalNumInputChannels () const noexcept
| Returns the total number of input channels.
int | getTotalNumOutputChannels () const noexcept
| Returns the total number of output channels.
int | getMainBusNumInputChannels () const noexcept
| Returns the number of input channels on the main bus.
int | getMainBusNumOutputChannels () const noexcept
| Returns the number of output channels on the main bus.
template<size_t numLayouts>
BusesLayout | getNextBestLayoutInLayoutList (const BusesLayout &layouts, const short(&channelLayoutList)[numLayouts][2])
| Returns the next best layout which is contained in a channel layout map.
double | getSampleRate () const noexcept
| Returns the current sample rate.
int | getBlockSize () const noexcept
| Returns the current typical block size that is being used.
int | getLatencySamples () const noexcept
| This returns the number of samples delay that the processor imposes on the audio passing through it.
void | setLatencySamples (int newLatency)
| Your processor subclass should call this to set the number of samples delay that it introduces.
virtual double | getTailLengthSeconds () const =0
| Returns the length of the processor's tail, in seconds.
virtual bool | acceptsMidi () const =0
| Returns true if the processor wants MIDI messages.
virtual bool | producesMidi () const =0
| Returns true if the processor produces MIDI messages.
virtual bool | supportsMPE () const
| Returns true if the processor supports MPE.
virtual bool | isMidiEffect () const
| Returns true if this is a MIDI effect plug-in and does no audio processing.
const CriticalSection & | getCallbackLock () const noexcept
| This returns a critical section that will automatically be locked while the host is calling the processBlock() method.
void | suspendProcessing (bool shouldBeSuspended)
| Enables and disables the processing callback.
bool | isSuspended () const noexcept
| Returns true if processing is currently suspended.
virtual void | reset ()
| A plugin can override this to be told when it should reset any playing voices.
virtual AudioProcessorParameter * | getBypassParameter () const
| Returns the parameter that controls the AudioProcessor's bypass state.
bool | isNonRealtime () const noexcept
| Returns true if the processor is being run in an offline mode for rendering.
Realtime | isRealtime () const noexcept
| Returns no if the processor is being run in an offline mode for rendering.
virtual void | setNonRealtime (bool isNonRealtime) noexcept
| Called by the host to tell this processor whether it's being used in a non-realtime capacity for offline rendering or bouncing.
virtual AudioProcessorEditor * | createEditor ()=0
| Creates the processor's GUI.
virtual bool | hasEditor () const =0
| Your processor subclass must override this and return true if it can create an editor component.
AudioProcessorEditor * | getActiveEditor () const noexcept
| Returns the active editor, if there is one.
AudioProcessorEditor * | createEditorIfNeeded ()
| Returns the active editor, or if there isn't one, it will create one.
void | updateHostDisplay (const ChangeDetails &details=ChangeDetails::getDefaultFlags())
| The processor can call this when something (apart from a parameter value) has changed.
void | addParameter (AudioProcessorParameter *)
| Adds a parameter to the AudioProcessor.
void | addParameterGroup (std::unique_ptr< AudioProcessorParameterGroup >)
| Adds a group of parameters to the AudioProcessor.
const AudioProcessorParameterGroup & | getParameterTree () const
| Returns the group of parameters managed by this AudioProcessor.
void | setParameterTree (AudioProcessorParameterGroup &&newTree)
| Sets the group of parameters managed by this AudioProcessor.
virtual void | refreshParameterList ()
| A processor should implement this method so that the host can ask it to rebuild its parameter tree.
const Array< AudioProcessorParameter * > & | getParameters () const
| Returns a flat list of the parameters in the current tree.
virtual int | getNumPrograms ()=0
| Returns the number of preset programs the processor supports.
virtual int | getCurrentProgram ()=0
| Returns the number of the currently active program.
virtual void | setCurrentProgram (int index)=0
| Called by the host to change the current program.
virtual const String | getProgramName (int index)=0
| Must return the name of a given program.
virtual void | changeProgramName (int index, const String &newName)=0
| Called by the host to rename a program.
virtual void | getStateInformation (MemoryBlock &destData)=0
| The host will call this method when it wants to save the processor's internal state.
virtual void | getCurrentProgramStateInformation (MemoryBlock &destData)
| The host will call this method if it wants to save the state of just the processor's current program.
virtual void | setStateInformation (const void *data, int sizeInBytes)=0
| This must restore the processor's state from a block of data previously created using getStateInformation().
virtual void | setCurrentProgramStateInformation (const void *data, int sizeInBytes)
| The host will call this method if it wants to restore the state of just the processor's current program.
virtual void | numChannelsChanged ()
| This method is called when the total number of input or output channels is changed.
virtual void | numBusesChanged ()
| This method is called when the number of buses is changed.
virtual void | processorLayoutsChanged ()
| This method is called when the layout of the audio processor changes.
virtual void | addListener (AudioProcessorListener *newListener)
| Adds a listener that will be called when an aspect of this processor changes.
virtual void | removeListener (AudioProcessorListener *listenerToRemove)
| Removes a previously added listener.
virtual void | setPlayHead (AudioPlayHead *newPlayHead)
| Tells the processor to use this playhead object.
void | setPlayConfigDetails (int numIns, int numOuts, double sampleRate, int blockSize)
| This is called by the processor to specify its details before being played.
void | setRateAndBufferSizeDetails (double sampleRate, int blockSize) noexcept
| This is called by the processor to specify its details before being played.
virtual void | audioWorkgroupContextChanged (const AudioWorkgroup &workgroup)
| This is called by the host when the thread workgroup context has changed.
virtual AAXClientExtensions & | getAAXClientExtensions ()
| Returns a reference to an object that implements AAX specific information regarding this AudioProcessor.
virtual VST2ClientExtensions * | getVST2ClientExtensions ()
| Returns a non-owning pointer to an object that implements VST2 specific information regarding this AudioProcessor.
virtual VST3ClientExtensions * | getVST3ClientExtensions ()
| Returns a non-owning pointer to an object that implements VST3 specific information regarding this AudioProcessor.
virtual CurveData | getResponseCurve (CurveData::Type) const
void | editorBeingDeleted (AudioProcessorEditor *) noexcept
| Not for public use - this is called before deleting an editor component.
virtual void | updateTrackProperties (const TrackProperties &properties)
| Informs the AudioProcessor that track properties such as the track's name or colour has been changed.
virtual std::optional< String > | getNameForMidiNoteNumber (int note, int midiChannel)
| Returns a custom name for a MIDI note number.

## Static Public Member Functions

static bool | containsLayout (const BusesLayout &layouts, const std::initializer_list< const short[2]> &channelLayoutList)
| Returns true if the channel layout map contains a certain layout.
template<size_t numLayouts>
static bool | containsLayout (const BusesLayout &layouts, const short(&channelLayoutList)[numLayouts][2])
static int | getDefaultNumParameterSteps () noexcept
| Returns the default number of steps for a parameter.
static const char * | getWrapperTypeDescription (AudioProcessor::WrapperType) noexcept
| Returns a textual description of a WrapperType value.
static void | copyXmlToBinary (const XmlElement &xml, MemoryBlock &destData)
| Helper function that just converts an xml element into a binary blob.
static std::unique_ptr< XmlElement > | getXmlFromBinary (const void *data, int sizeInBytes)
| Retrieves an XML element that was stored as binary with the copyXmlToBinary() method.
static void JUCE_CALLTYPE | setTypeOfNextNewPlugin (WrapperType)

## Public Attributes

const WrapperType | wrapperType
| When loaded by a plugin wrapper, this flag will be set to indicate the type of plugin within which the processor is running.

## Protected Member Functions

| AudioProcessor ()
| Constructor.
| AudioProcessor (const BusesProperties &ioLayouts)
| Constructor for multi-bus AudioProcessors.
| AudioProcessor (const std::initializer_list< const short[2]> &channelLayoutList)
| Constructor for AudioProcessors which use layout maps If your AudioProcessor uses layout maps then use this constructor.
virtual bool | isBusesLayoutSupported (const BusesLayout &) const
| Callback to query if the AudioProcessor supports a specific layout.
virtual bool | canApplyBusesLayout (const BusesLayout &layouts) const
| Callback to check if a certain bus layout can now be applied.
virtual bool | applyBusLayouts (const BusesLayout &layouts)
| This method will be called when a new bus layout needs to be applied.
virtual bool | canApplyBusCountChange (bool isInput, bool isAddingBuses, BusProperties &outNewBusProperties)
| Callback to query if adding/removing buses currently possible.

## Protected Attributes

std::atomic< AudioPlayHead * > | playHead { nullptr }

## Member Typedef Documentation

## ChangeDetails

using juce::AudioProcessor::ChangeDetails = AudioProcessorListener::ChangeDetails

## Member Enums

## ProcessingPrecision

enum juce::AudioProcessor::ProcessingPrecision

Enumerator
singlePrecision |
doublePrecision |

## Realtime

enum class juce::AudioProcessor::Realtime

strong

Enumerator
no |
yes |

## WrapperType

enum juce::AudioProcessor::WrapperType

Flags to indicate the type of plugin context in which a processor is being used.

Enumerator
wrapperType_Undefined |
wrapperType_VST |
wrapperType_VST3 |
wrapperType_AudioUnit |
wrapperType_AudioUnitv3 |
wrapperType_AAX |
wrapperType_Standalone |
wrapperType_Unity |
wrapperType_LV2 |

## Constructors and Destructors

## AudioProcessor() [1/3]

juce::AudioProcessor::AudioProcessor | ( |  | ) |

protected

Constructor.

This constructor will create a main input and output bus which are disabled by default. If you need more fine-grained control then use the other constructors.

Referenced by AudioProcessor(), juce::AudioProcessorGraph::Node::getProcessor(), juce::AudioProcessor::ParameterChangeForwarder::ParameterChangeForwarder(), and juce::AudioProcessor::ParameterChangeForwarder::parameterGestureChanged().

## AudioProcessor() [2/3]

juce::AudioProcessor::AudioProcessor | ( | const BusesProperties & | ioLayouts | ) |

protected

Constructor for multi-bus AudioProcessors.

If your AudioProcessor supports multiple buses than use this constructor to initialise the bus layouts and bus names of your plug-in.

## AudioProcessor() [3/3]

juce::AudioProcessor::AudioProcessor | ( | const std::initializer_list< const short[2]> & | channelLayoutList | ) |

inline protected

Constructor for AudioProcessors which use layout maps If your AudioProcessor uses layout maps then use this constructor.

References AudioProcessor().

## ~AudioProcessor()

virtual juce::AudioProcessor::~AudioProcessor | ( |  | ) |

virtual

Destructor.

## Member Functions

## getName()

virtual const String juce::AudioProcessor::getName | ( |  | ) | const

pure virtual

Returns the name of this processor.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## getAlternateDisplayNames()

virtual StringArray juce::AudioProcessor::getAlternateDisplayNames | ( |  | ) | const

virtual

Returns a list of alternative names to use for this processor.

Some hosts truncate the name of your AudioProcessor when there isn't enough space in the GUI to show the full name. Overriding this method, allows the host to choose an alternative name (such as an abbreviation) to better fit the available space.

## prepareToPlay()

virtual void juce::AudioProcessor::prepareToPlay | ( | double | sampleRate,
|  | int | maximumExpectedSamplesPerBlock )

pure virtual

Called before playback starts, to let the processor prepare itself.

The sample rate is the target sample rate, and will remain constant until playback stops.

You can call getTotalNumInputChannels and getTotalNumOutputChannels or query the busLayout member variable to find out the number of channels your processBlock callback must process.

The maximumExpectedSamplesPerBlock value is a strong hint about the maximum number of samples that will be provided in each block. You may want to use this value to resize internal buffers. You should program defensively in case a buggy host exceeds this value. The actual block sizes that the host uses may be different each time the callback happens: completely variable block sizes can be expected from some hosts.

See also
  busLayout, getTotalNumInputChannels, getTotalNumOutputChannels

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## releaseResources()

virtual void juce::AudioProcessor::releaseResources | ( |  | ) |

pure virtual

Called after playback has stopped, to let the object free up any resources it no longer needs.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## memoryWarningReceived()

virtual void juce::AudioProcessor::memoryWarningReceived | ( |  | ) |

inline virtual

Called by the host to indicate that you should reduce your memory footprint.

You should override this method to free up some memory gracefully, if possible, otherwise the host may forcibly unload your AudioProcessor.

At the moment this method is only called when your AudioProcessor is an AUv3 plug-in running on iOS.

References jassertfalse.

## processBlock() [1/2]

virtual void juce::AudioProcessor::processBlock | ( | AudioBuffer< float > & | buffer,
|  | MidiBuffer & | midiMessages )

pure virtual

Renders the next block.

When this method is called, the buffer contains a number of channels which is at least as great as the maximum number of input and output channels that this processor is using. It will be filled with the processor's input data and should be replaced with the processor's output.

So for example if your processor has a total of 2 input channels and 4 output channels, then the buffer will contain 4 channels, the first two being filled with the input data. Your processor should read these, do its processing, and replace the contents of all 4 channels with its output.

Or if your processor has a total of 5 inputs and 2 outputs, the buffer will have 5 channels, all filled with data, and your processor should overwrite the first 2 of these with its output. But be VERY careful not to write anything to the last 3 channels, as these might be mapped to memory that the host assumes is read-only!

If your plug-in has more than one input or output buses then the buffer passed to the processBlock methods will contain a bundle of all channels of each bus. Use getBusBuffer to obtain an audio buffer for a particular bus.

Note that if you have more outputs than inputs, then only those channels that correspond to an input channel are guaranteed to contain sensible data - e.g. in the case of 2 inputs and 4 outputs, the first two channels contain the input, but the last two channels may contain garbage, so you should be careful not to let this pass through without being overwritten or cleared.

Also note that the buffer may have more channels than are strictly necessary, but you should only read/write from the ones that your processor is supposed to be using.

The number of samples in these buffers is NOT guaranteed to be the same for every callback, and may be more or less than the estimated value given to prepareToPlay(). Your code must be able to cope with variable-sized blocks, or you're going to get clicks and crashes!

Also note that some hosts will occasionally decide to pass a buffer containing zero samples, so make sure that your algorithm can deal with that!

If the processor is receiving a MIDI input, then the midiMessages array will be filled with the MIDI messages for this block. Each message's timestamp will indicate the message's time, as a number of samples from the start of the block.

Any messages left in the MIDI buffer when this method has finished are assumed to be the processor's MIDI output. This means that your processor should be careful to clear any incoming messages from the array if it doesn't want them to be passed-on.

If you have implemented the getBypassParameter method, then you need to check the value of this parameter in this callback and bypass your processing if the parameter has a non-zero value.

Note that when calling this method as a host, the result may still be bypassed as the parameter that controls the bypass may be non-zero.

Be very careful about what you do in this callback - it's going to be called by the audio thread, so any kind of interaction with the UI is absolutely out of the question. If you change a parameter in here and need to tell your UI to update itself, the best way is probably to inherit from a ChangeBroadcaster, let the UI components register as listeners, and then call sendChangeMessage() inside the processBlock() method to send out an asynchronous message. You could also use the AsyncUpdater class in a similar way.

See also
  getBusBuffer

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## processBlock() [2/2]

virtual void juce::AudioProcessor::processBlock | ( | AudioBuffer< double > & | buffer,
|  | MidiBuffer & | midiMessages )

virtual

Renders the next block.

When this method is called, the buffer contains a number of channels which is at least as great as the maximum number of input and output channels that this processor is using. It will be filled with the processor's input data and should be replaced with the processor's output.

So for example if your processor has a combined total of 2 input channels and 4 output channels, then the buffer will contain 4 channels, the first two being filled with the input data. Your processor should read these, do its processing, and replace the contents of all 4 channels with its output.

Or if your processor has 5 inputs and 2 outputs, the buffer will have 5 channels, all filled with data, and your processor should overwrite the first 2 of these with its output. But be VERY careful not to write anything to the last 3 channels, as these might be mapped to memory that the host assumes is read-only!

If your plug-in has more than one input or output buses then the buffer passed to the processBlock methods will contain a bundle of all channels of each bus. Use getBusBuffer to obtain a audio buffer for a particular bus.

Note that if you have more outputs than inputs, then only those channels that correspond to an input channel are guaranteed to contain sensible data - e.g. in the case of 2 inputs and 4 outputs, the first two channels contain the input, but the last two channels may contain garbage, so you should be careful not to let this pass through without being overwritten or cleared.

Also note that the buffer may have more channels than are strictly necessary, but you should only read/write from the ones that your processor is supposed to be using.

If your plugin uses buses, then you should use getBusBuffer() or getChannelIndexInProcessBlockBuffer() to find out which of the input and output channels correspond to which of the buses.

The number of samples in these buffers is NOT guaranteed to be the same for every callback, and may be more or less than the estimated value given to prepareToPlay(). Your code must be able to cope with variable-sized blocks, or you're going to get clicks and crashes!

Also note that some hosts will occasionally decide to pass a buffer containing zero samples, so make sure that your algorithm can deal with that!

If the processor is receiving a MIDI input, then the midiMessages array will be filled with the MIDI messages for this block. Each message's timestamp will indicate the message's time, as a number of samples from the start of the block.

Any messages left in the MIDI buffer when this method has finished are assumed to be the processor's MIDI output. This means that your processor should be careful to clear any incoming messages from the array if it doesn't want them to be passed-on.

If you have implemented the getBypassParameter method, then you need to check the value of this parameter in this callback and bypass your processing if the parameter has a non-zero value.

Note that when calling this method as a host, the result may still be bypassed as the parameter that controls the bypass may be non-zero.

Be very careful about what you do in this callback - it's going to be called by the audio thread, so any kind of interaction with the UI is absolutely out of the question. If you change a parameter in here and need to tell your UI to update itself, the best way is probably to inherit from a ChangeBroadcaster, let the UI components register as listeners, and then call sendChangeMessage() inside the processBlock() method to send out an asynchronous message. You could also use the AsyncUpdater class in a similar way.

See also
  getBusBuffer

Reimplemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## processBlockBypassed() [1/2]

virtual void juce::AudioProcessor::processBlockBypassed | ( | AudioBuffer< float > & | buffer,
|  | MidiBuffer & | midiMessages )

virtual

Renders the next block when the processor is being bypassed.

The default implementation of this method will pass-through any incoming audio, but you may override this method e.g. to add latency compensation to the data to match the processor's latency characteristics. This will avoid situations where bypassing will shift the signal forward in time, possibly creating pre-echo effects and odd timings. Another use for this method would be to cross-fade or morph between the wet (not bypassed) and dry (bypassed) signals.

## processBlockBypassed() [2/2]

virtual void juce::AudioProcessor::processBlockBypassed | ( | AudioBuffer< double > & | buffer,
|  | MidiBuffer & | midiMessages )

virtual

Renders the next block when the processor is being bypassed.

The default implementation of this method will pass-through any incoming audio, but you may override this method e.g. to add latency compensation to the data to match the processor's latency characteristics. This will avoid situations where bypassing will shift the signal forward in time, possibly creating pre-echo effects and odd timings. Another use for this method would be to cross-fade or morph between the wet (not bypassed) and dry (bypassed) signals.

## getBusCount()

int juce::AudioProcessor::getBusCount | ( | bool | isInput | ) | const

inline noexcept

Returns the number of buses on the input or output side.

References getBusCount().

Referenced by getBusCount().

## getBus() [1/2]

Bus * juce::AudioProcessor::getBus | ( | bool | isInput,
|  | int | busIndex )

inline noexcept

Returns the audio bus with a given index and direction.

If busIndex is invalid then this method will return a nullptr.

Referenced by getChannelCountOfBus().

## getBus() [2/2]

const Bus * juce::AudioProcessor::getBus | ( | bool | isInput,
|  | int | busIndex ) const

inline noexcept

Returns the audio bus with a given index and direction.

If busIndex is invalid then this method will return a nullptr.

## canAddBus()

virtual bool juce::AudioProcessor::canAddBus | ( | bool | isInput | ) | const

virtual

Callback to query if a bus can currently be added.

This callback probes if a bus can currently be added. You should override this callback if you want to support dynamically adding/removing buses by the host. This is useful for mixer audio processors.

The default implementation will always return false.

See also
  addBus

## canRemoveBus()

virtual bool juce::AudioProcessor::canRemoveBus | ( | bool | isInput | ) | const

virtual

Callback to query if the last bus can currently be removed.

This callback probes if the last bus can currently be removed. You should override this callback if you want to support dynamically adding/removing buses by the host. This is useful for mixer audio processors.

If you return true in this callback then the AudioProcessor will go ahead and delete the bus.

The default implementation will always return false.

## addBus()

bool juce::AudioProcessor::addBus | ( | bool | isInput | ) |

Dynamically request an additional bus.

Request an additional bus from the audio processor. If the audio processor does not support adding additional buses then this method will return false.

Most audio processors will not allow you to dynamically add/remove audio buses and will return false.

This method will invoke the canApplyBusCountChange callback to probe if a bus can be added and, if yes, will use the supplied bus properties of the canApplyBusCountChange callback to create a new bus.

See also
  canApplyBusCountChange, removeBus

## removeBus()

bool juce::AudioProcessor::removeBus | ( | bool | isInput | ) |

Dynamically remove the latest added bus.

Request the removal of the last bus from the audio processor. If the audio processor does not support removing buses then this method will return false.

Most audio processors will not allow you to dynamically add/remove audio buses and will return false.

The default implementation will return false.

This method will invoke the canApplyBusCountChange callback to probe if a bus can currently be removed and, if yes, will go ahead and remove it.

See also
  addBus, canRemoveBus

## setBusesLayout()

bool juce::AudioProcessor::setBusesLayout | ( | const BusesLayout & |  | ) |

Set the channel layouts of this audio processor.

If the layout is not supported by this audio processor then this method will return false. You can use the checkBusesLayoutSupported and getNextBestLayout methods to probe which layouts this audio processor supports.

## setBusesLayoutWithoutEnabling()

bool juce::AudioProcessor::setBusesLayoutWithoutEnabling | ( | const BusesLayout & |  | ) |

Set the channel layouts of this audio processor without changing the enablement state of the buses.

If the layout is not supported by this audio processor then this method will return false. You can use the checkBusesLayoutSupported methods to probe which layouts this audio processor supports.

## getBusesLayout()

BusesLayout juce::AudioProcessor::getBusesLayout | ( |  | ) | const

Provides the current channel layouts of this audio processor.

## getChannelLayoutOfBus()

AudioChannelSet juce::AudioProcessor::getChannelLayoutOfBus | ( | bool | isInput,
|  | int | busIndex ) const

noexcept

Provides the channel layout of the bus with a given index and direction.

If the index, direction combination is invalid then this will return an AudioChannelSet with no channels.

## setChannelLayoutOfBus()

bool juce::AudioProcessor::setChannelLayoutOfBus | ( | bool | isInput,
|  | int | busIndex,
|  | const AudioChannelSet & | layout )

Set the channel layout of the bus with a given index and direction.

If the index, direction combination is invalid or the layout is not supported by the audio processor then this method will return false.

## getChannelCountOfBus()

int juce::AudioProcessor::getChannelCountOfBus | ( | bool | isInput,
|  | int | busIndex ) const

inline noexcept

Provides the number of channels of the bus with a given index and direction.

If the index, direction combination is invalid then this will return zero.

References getBus().

Referenced by getBusBuffer(), getMainBusNumInputChannels(), and getMainBusNumOutputChannels().

## enableAllBuses()

bool juce::AudioProcessor::enableAllBuses | ( |  | ) |

Enables all buses.

## disableNonMainBuses()

bool juce::AudioProcessor::disableNonMainBuses | ( |  | ) |

Disables all non-main buses (aux and sidechains).

## getChannelIndexInProcessBlockBuffer()

int juce::AudioProcessor::getChannelIndexInProcessBlockBuffer | ( | bool | isInput,
|  | int | busIndex,
|  | int | channelIndex ) const

noexcept

Returns the position of a bus's channels within the processBlock buffer.

This can be called in processBlock to figure out which channel of the master AudioBuffer maps onto a specific bus's channel.

Referenced by getBusBuffer().

## getOffsetInBusBufferForAbsoluteChannelIndex()

int juce::AudioProcessor::getOffsetInBusBufferForAbsoluteChannelIndex | ( | bool | isInput,
|  | int | absoluteChannelIndex,
|  | int & | busIndex ) const

noexcept

Returns the offset in a bus's buffer from an absolute channel index.

This method returns the offset in a bus's buffer given an absolute channel index. It also provides the bus index. For example, this method would return one for a processor with two stereo buses when given the absolute channel index.

## getBusBuffer()

template<typename FloatType>

AudioBuffer< FloatType > juce::AudioProcessor::getBusBuffer | ( | AudioBuffer< FloatType > & | processBlockBuffer,
|  | bool | isInput,
|  | int | busIndex ) const

inline

Returns an AudioBuffer containing a set of channel pointers for a specific bus.

This can be called in processBlock to get a buffer containing a sub-group of the master AudioBuffer which contains all the plugin channels.

References juce::AudioBuffer< Type >::getArrayOfWritePointers(), getChannelCountOfBus(), getChannelIndexInProcessBlockBuffer(), and juce::AudioBuffer< Type >::getNumSamples().

## checkBusesLayoutSupported()

bool juce::AudioProcessor::checkBusesLayoutSupported | ( | const BusesLayout & |  | ) | const

Returns true if the Audio processor is likely to support a given layout.

This can be called regardless if the processor is currently running.

## supportsDoublePrecisionProcessing()

virtual bool juce::AudioProcessor::supportsDoublePrecisionProcessing | ( |  | ) | const

virtual

Returns true if the Audio processor supports double precision floating point processing.

The default implementation will always return false. If you return true here then you must override the double precision versions of processBlock. Additionally, you must call getProcessingPrecision() in your prepareToPlay method to determine the precision with which you need to allocate your internal buffers.

See also
  getProcessingPrecision, setProcessingPrecision

Reimplemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## getProcessingPrecision()

ProcessingPrecision juce::AudioProcessor::getProcessingPrecision | ( |  | ) | const

inline noexcept

Returns the precision-mode of the processor.

Depending on the result of this method you MUST call the corresponding version of processBlock. The default processing precision is single precision.

See also
  setProcessingPrecision, supportsDoublePrecisionProcessing

## isUsingDoublePrecision()

bool juce::AudioProcessor::isUsingDoublePrecision | ( |  | ) | const

inline noexcept

Returns true if the current precision is set to doublePrecision.

References doublePrecision.

## setProcessingPrecision()

void juce::AudioProcessor::setProcessingPrecision | ( | ProcessingPrecision | newPrecision | ) |

noexcept

Changes the processing precision of the receiver.

A client of the AudioProcessor calls this function to indicate which version of processBlock (single or double precision) it intends to call. The client MUST call this function before calling the prepareToPlay method so that the receiver can do any necessary allocations in the prepareToPlay() method. An implementation of prepareToPlay() should call getProcessingPrecision() to determine with which precision it should allocate it's internal buffers.

Note that setting the processing precision to double floating point precision on a receiver which does not support double precision processing (i.e. supportsDoublePrecisionProcessing() returns false) will result in an assertion.

See also
  getProcessingPrecision, supportsDoublePrecisionProcessing

## getPlayHead()

AudioPlayHead * juce::AudioProcessor::getPlayHead | ( |  | ) | const

inline noexcept

Returns the current AudioPlayHead object that should be used to find out the state and position of the playhead.

You can ONLY call this from your processBlock() method! Calling it at other times will produce undefined behaviour, as the host may not have any context in which a time would make sense, and some hosts will almost certainly have multithreading issues if it's not called on the audio thread.

The AudioPlayHead object that is returned can be used to get the details about the time of the start of the block currently being processed. But do not store this pointer or use it outside of the current audio callback, because the host may delete or re-use it.

If the host can't or won't provide any time info, this will return nullptr.

References playHead.

## getTotalNumInputChannels()

int juce::AudioProcessor::getTotalNumInputChannels | ( |  | ) | const

inline noexcept

Returns the total number of input channels.

This method will return the total number of input channels by accumulating the number of channels on each input bus. The number of channels of the buffer passed to your processBlock callback will be equivalent to either getTotalNumInputChannels or getTotalNumOutputChannels - which ever is greater.

Note that getTotalNumInputChannels is equivalent to getMainBusNumInputChannels if your processor does not have any sidechains or aux buses.

## getTotalNumOutputChannels()

int juce::AudioProcessor::getTotalNumOutputChannels | ( |  | ) | const

inline noexcept

Returns the total number of output channels.

This method will return the total number of output channels by accumulating the number of channels on each output bus. The number of channels of the buffer passed to your processBlock callback will be equivalent to either getTotalNumInputChannels or getTotalNumOutputChannels - which ever is greater.

Note that getTotalNumOutputChannels is equivalent to getMainBusNumOutputChannels if your processor does not have any sidechains or aux buses.

## getMainBusNumInputChannels()

int juce::AudioProcessor::getMainBusNumInputChannels | ( |  | ) | const

inline noexcept

Returns the number of input channels on the main bus.

References getChannelCountOfBus().

## getMainBusNumOutputChannels()

int juce::AudioProcessor::getMainBusNumOutputChannels | ( |  | ) | const

inline noexcept

Returns the number of output channels on the main bus.

References getChannelCountOfBus().

## containsLayout() [1/2]

bool juce::AudioProcessor::containsLayout | ( | const BusesLayout & | layouts,
|  | const std::initializer_list< const short[2]> & | channelLayoutList )

inline static

Returns true if the channel layout map contains a certain layout.

You can use this method to help you implement the checkBusesLayoutSupported method. For example

bool checkBusesLayoutSupported (const BusesLayout& layouts) override
{
return containsLayout (layouts, {{1,1},{2,2}});
}
juce::AudioProcessor::checkBusesLayoutSupported
bool checkBusesLayoutSupported(const BusesLayout &) const
Returns true if the Audio processor is likely to support a given layout.
juce::AudioProcessor::containsLayout
static bool containsLayout(const BusesLayout &layouts, const std::initializer_list< const short[2]> &channelLayoutList)
Returns true if the channel layout map contains a certain layout.
Definition juce_AudioProcessor.h:789
juce::AudioProcessor::BusesLayout
Represents the bus layout state of a plug-in.
Definition juce_AudioProcessor.h:324

References containsLayout().

Referenced by containsLayout(), and containsLayout().

## containsLayout() [2/2]

template<size_t numLayouts>

bool juce::AudioProcessor::containsLayout | ( | const BusesLayout & | layouts,
|  | const short(&) | channelLayoutList[numLayouts][2] )

inline static

References containsLayout().

## getNextBestLayoutInLayoutList()

template<size_t numLayouts>

BusesLayout juce::AudioProcessor::getNextBestLayoutInLayoutList | ( | const BusesLayout & | layouts,
|  | const short(&) | channelLayoutList[numLayouts][2] )

inline

Returns the next best layout which is contained in a channel layout map.

You can use this method to help you implement getNextBestLayout. For example:

BusesLayout getNextBestLayout (const BusesLayout& layouts) override
{
return getNextBestLayoutInLayoutList (layouts, {{1,1},{2,2}});
}
juce::AudioProcessor::getNextBestLayoutInLayoutList
BusesLayout getNextBestLayoutInLayoutList(const BusesLayout &layouts, const short(&channelLayoutList)[numLayouts][2])
Returns the next best layout which is contained in a channel layout map.
Definition juce_AudioProcessor.h:812

## getSampleRate()

double juce::AudioProcessor::getSampleRate | ( |  | ) | const

inline noexcept

Returns the current sample rate.

This can be called from your processBlock() method - it's not guaranteed to be valid at any other time, and may return 0 if it's unknown.

## getBlockSize()

int juce::AudioProcessor::getBlockSize | ( |  | ) | const

inline noexcept

Returns the current typical block size that is being used.

This can be called from your processBlock() method - it's not guaranteed to be valid at any other time.

Remember it's not the ONLY block size that may be used when calling processBlock, it's just the normal one. The actual block sizes used may be larger or smaller than this, and will vary between successive calls.

## getLatencySamples()

int juce::AudioProcessor::getLatencySamples | ( |  | ) | const

inline noexcept

This returns the number of samples delay that the processor imposes on the audio passing through it.

The host will call this to find the latency - the processor itself should set this value by calling setLatencySamples() as soon as it can during its initialisation.

## setLatencySamples()

void juce::AudioProcessor::setLatencySamples | ( | int | newLatency | ) |

Your processor subclass should call this to set the number of samples delay that it introduces.

The processor should call this as soon as it can during initialisation, and can call it later if the value changes.

## getTailLengthSeconds()

virtual double juce::AudioProcessor::getTailLengthSeconds | ( |  | ) | const

pure virtual

Returns the length of the processor's tail, in seconds.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## acceptsMidi()

virtual bool juce::AudioProcessor::acceptsMidi | ( |  | ) | const

pure virtual

Returns true if the processor wants MIDI messages.

This must return the same value every time it is called. This may be called by the audio thread, so this should be fast. Ideally, just return a constant.

Implemented in juce::AudioProcessorGraph, and juce::AudioProcessorGraph::AudioGraphIOProcessor.

## producesMidi()

virtual bool juce::AudioProcessor::producesMidi | ( |  | ) | const

pure virtual

Returns true if the processor produces MIDI messages.

This must return the same value every time it is called. This may be called by the audio thread, so this should be fast. Ideally, just return a constant.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## supportsMPE()

virtual bool juce::AudioProcessor::supportsMPE | ( |  | ) | const

inline virtual

Returns true if the processor supports MPE.

This must return the same value every time it is called. This may be called by the audio thread, so this should be fast. Ideally, just return a constant.

## isMidiEffect()

virtual bool juce::AudioProcessor::isMidiEffect | ( |  | ) | const

inline virtual

Returns true if this is a MIDI effect plug-in and does no audio processing.

This must return the same value every time it is called. This may be called by the audio thread, so this should be fast. Ideally, just return a constant.

## getCallbackLock()

const CriticalSection & juce::AudioProcessor::getCallbackLock | ( |  | ) | const

inline noexcept

This returns a critical section that will automatically be locked while the host is calling the processBlock() method.

Use it from your UI or other threads to lock access to variables that are used by the process callback, but obviously be careful not to keep it locked for too long, because that could cause stuttering playback. If you need to do something that'll take a long time and need the processing to stop while it happens, use the suspendProcessing() method instead.

See also
  suspendProcessing

## suspendProcessing()

void juce::AudioProcessor::suspendProcessing | ( | bool | shouldBeSuspended | ) |

Enables and disables the processing callback.

If you need to do something time-consuming on a thread and would like to make sure the audio processing callback doesn't happen until you've finished, use this to disable the callback and re-enable it again afterwards.

E.g.

void loadNewPatch()
{
suspendProcessing (true);
...do something that takes ages...
suspendProcessing (false);
}
juce::AudioProcessor::suspendProcessing
void suspendProcessing(bool shouldBeSuspended)
Enables and disables the processing callback.

If the host tries to make an audio callback while processing is suspended, the processor will return an empty buffer, but won't block the audio thread like it would do if you use the getCallbackLock() critical section to synchronise access.

Any code that calls processBlock() should call isSuspended() before doing so, and if the processor is suspended, it should avoid the call and emit silence or whatever is appropriate.

See also
  getCallbackLock

## isSuspended()

bool juce::AudioProcessor::isSuspended | ( |  | ) | const

inline noexcept

Returns true if processing is currently suspended.

See also
  suspendProcessing

## reset()

virtual void juce::AudioProcessor::reset | ( |  | ) |

virtual

A plugin can override this to be told when it should reset any playing voices.

The default implementation does nothing, but a host may call this to tell the plugin that it should stop any tails or sounds that have been left running.

Reimplemented in juce::AudioProcessorGraph.

## getBypassParameter()

virtual AudioProcessorParameter * juce::AudioProcessor::getBypassParameter | ( |  | ) | const

inline virtual

Returns the parameter that controls the AudioProcessor's bypass state.

If this method returns a nullptr then you can still control the bypass by calling processBlockBypassed instead of processBlock. On the other hand, if this method returns a non-null value, you should never call processBlockBypassed but use the returned parameter to control the bypass state instead.

A plug-in can override this function to return a parameter which controls your plug-in's bypass. You should always check the value of this parameter in your processBlock callback and bypass any effects if it is non-zero.

## isNonRealtime()

bool juce::AudioProcessor::isNonRealtime | ( |  | ) | const

inline noexcept

Returns true if the processor is being run in an offline mode for rendering.

If the processor is being run live on realtime signals, this returns false. If the mode is unknown, this will assume it's realtime and return false.

This value may be unreliable until the prepareToPlay() method has been called, and could change each time prepareToPlay() is called.

See also
  setNonRealtime()

Referenced by isRealtime(), and setNonRealtime().

## isRealtime()

Realtime juce::AudioProcessor::isRealtime | ( |  | ) | const

inline noexcept

Returns no if the processor is being run in an offline mode for rendering.

If the processor is being run live on realtime signals, this returns yes. If the mode is unknown, this will assume it's realtime and return yes.

This value may be unreliable until the prepareToPlay() method has been called, and could change each time prepareToPlay() is called.

See also
  setNonRealtime()

References isNonRealtime(), no, and yes.

## setNonRealtime()

virtual void juce::AudioProcessor::setNonRealtime | ( | bool | isNonRealtime | ) |

virtual noexcept

Called by the host to tell this processor whether it's being used in a non-realtime capacity for offline rendering or bouncing.

Reimplemented in juce::AudioProcessorGraph.

References isNonRealtime().

## createEditor()

virtual AudioProcessorEditor * juce::AudioProcessor::createEditor | ( |  | ) |

pure virtual

Creates the processor's GUI.

This can return nullptr if you want a GUI-less processor, in which case the host may create a generic UI that lets the user twiddle the parameters directly.

If you do want to pass back a component, the component should be created and set to the correct size before returning it. If you implement this method, you must also implement the hasEditor() method and make it return true.

Remember not to do anything like allowing your processor to keep a pointer to the component that gets created - it could be deleted later without any warning, which would make your pointer into a dangler. Use the getActiveEditor() method instead.

The correct way to handle the connection between an editor component and its processor is to use something like a ChangeBroadcaster so that the editor can register itself as a listener, and be told when a change occurs. This lets them safely unregister themselves when they are deleted.

Here are a few things to bear in mind when writing an editor:

- Initially there won't be an editor, until the user opens one, or they might not open one at all. Your processor mustn't rely on it being there.
- An editor object may be deleted and a replacement one created again at any time.
- It's safe to assume that an editor will be deleted before its processor.

See also
  hasEditor

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## hasEditor()

virtual bool juce::AudioProcessor::hasEditor | ( |  | ) | const

pure virtual

Your processor subclass must override this and return true if it can create an editor component.

See also
  createEditor

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

## getActiveEditor()

AudioProcessorEditor * juce::AudioProcessor::getActiveEditor | ( |  | ) | const

noexcept

Returns the active editor, if there is one.

Bear in mind this can return nullptr even if an editor has previously been opened.

Note that you should only call this method from the message thread as the active editor may be deleted by the message thread, causing a dangling pointer.

The returned pointer is non-owning! If you're planning to store this pointer, it's a good idea to immediately wrap this in a Component::SafePointer or similar so that you don't try to use the editor after the owner destroys it.

## createEditorIfNeeded()

AudioProcessorEditor * juce::AudioProcessor::createEditorIfNeeded | ( |  | ) |

Returns the active editor, or if there isn't one, it will create one.

This may call createEditor() internally to create the component.

References createEditorIfNeeded().

Referenced by createEditorIfNeeded().

## getDefaultNumParameterSteps()

int juce::AudioProcessor::getDefaultNumParameterSteps | ( |  | ) |

static noexcept

Returns the default number of steps for a parameter.

NOTE! This method is deprecated! It's recommended that you use AudioProcessorParameter::getNumSteps() instead.

See also
  getParameterNumSteps

References getDefaultNumParameterSteps().

Referenced by getDefaultNumParameterSteps().

## updateHostDisplay()

void juce::AudioProcessor::updateHostDisplay | ( | const ChangeDetails & | details = ChangeDetails::getDefaultFlags() | ) |

The processor can call this when something (apart from a parameter value) has changed.

It sends a hint to the host that something like the program, number of parameters, etc, has changed, and that it should update itself.

References updateHostDisplay().

Referenced by updateHostDisplay().

## addParameter()

void juce::AudioProcessor::addParameter | ( | AudioProcessorParameter * |  | ) |

Adds a parameter to the AudioProcessor.

The parameter object will be managed and deleted automatically by the AudioProcessor when no longer needed.

References addParameter().

Referenced by addParameter().

## addParameterGroup()

void juce::AudioProcessor::addParameterGroup | ( | std::unique_ptr< AudioProcessorParameterGroup > |  | ) |

Adds a group of parameters to the AudioProcessor.

All the parameter objects contained within the group will be managed and deleted automatically by the AudioProcessor when no longer needed.

See also
  addParameter

References addParameterGroup().

Referenced by addParameterGroup().

## getParameterTree()

const AudioProcessorParameterGroup & juce::AudioProcessor::getParameterTree | ( |  | ) | const

Returns the group of parameters managed by this AudioProcessor.

References getParameterTree().

Referenced by getParameterTree(), and juce::LegacyAudioParametersWrapper::update().

## setParameterTree()

void juce::AudioProcessor::setParameterTree | ( | AudioProcessorParameterGroup && | newTree | ) |

Sets the group of parameters managed by this AudioProcessor.

Replacing the tree after your AudioProcessor has been constructed will crash many hosts, so don't do it! You may, however, change parameter and group names by iterating the tree returned by getParameterTree(). Afterwards, call updateHostDisplay() to inform the host of the changes. Not all hosts support dynamic changes to parameters and group names.

References setParameterTree().

Referenced by setParameterTree().

## refreshParameterList()

virtual void juce::AudioProcessor::refreshParameterList | ( |  | ) |

virtual

A processor should implement this method so that the host can ask it to rebuild its parameter tree.

For most plug-ins it's enough to simply add your parameters in the constructor and leave this unimplemented.

References refreshParameterList().

Referenced by refreshParameterList().

## getParameters()

const Array< AudioProcessorParameter * > & juce::AudioProcessor::getParameters | ( |  | ) | const

Returns a flat list of the parameters in the current tree.

References getParameters().

Referenced by getParameters(), and juce::LegacyAudioParametersWrapper::update().

## getNumPrograms()

virtual int juce::AudioProcessor::getNumPrograms | ( |  | ) |

pure virtual

Returns the number of preset programs the processor supports.

The value returned must be valid as soon as this object is created, and must not change over its lifetime.

This value shouldn't be less than 1.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

References getNumPrograms().

Referenced by getNumPrograms().

## getCurrentProgram()

virtual int juce::AudioProcessor::getCurrentProgram | ( |  | ) |

pure virtual

Returns the number of the currently active program.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

References getCurrentProgram().

Referenced by getCurrentProgram().

## setCurrentProgram()

virtual void juce::AudioProcessor::setCurrentProgram | ( | int | index | ) |

pure virtual

Called by the host to change the current program.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

References setCurrentProgram().

Referenced by setCurrentProgram().

## getProgramName()

virtual const String juce::AudioProcessor::getProgramName | ( | int | index | ) |

pure virtual

Must return the name of a given program.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

References getProgramName().

Referenced by getProgramName().

## changeProgramName()

virtual void juce::AudioProcessor::changeProgramName | ( | int | index,
|  | const String & | newName )

pure virtual

Called by the host to rename a program.

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

References changeProgramName().

Referenced by changeProgramName().

## getStateInformation()

virtual void juce::AudioProcessor::getStateInformation | ( | MemoryBlock & | destData | ) |

pure virtual

The host will call this method when it wants to save the processor's internal state.

This must copy any info about the processor's state into the block of memory provided, so that the host can store this and later restore it using setStateInformation().

Note that there's also a getCurrentProgramStateInformation() method, which only stores the current program, not the state of the entire processor.

See also the helper function copyXmlToBinary() for storing settings as XML.

See also
  getCurrentProgramStateInformation

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

References getStateInformation().

Referenced by getStateInformation().

## getCurrentProgramStateInformation()

virtual void juce::AudioProcessor::getCurrentProgramStateInformation | ( | MemoryBlock & | destData | ) |

virtual

The host will call this method if it wants to save the state of just the processor's current program.

Unlike getStateInformation, this should only return the current program's state.

Not all hosts support this, and if you don't implement it, the base class method just calls getStateInformation() instead. If you do implement it, be sure to also implement getCurrentProgramStateInformation.

See also
  getStateInformation, setCurrentProgramStateInformation

References getCurrentProgramStateInformation().

Referenced by getCurrentProgramStateInformation().

## setStateInformation()

virtual void juce::AudioProcessor::setStateInformation | ( | const void * | data,
|  | int | sizeInBytes )

pure virtual

This must restore the processor's state from a block of data previously created using getStateInformation().

Note that there's also a setCurrentProgramStateInformation() method, which tries to restore just the current program, not the state of the entire processor.

See also the helper function getXmlFromBinary() for loading settings as XML.

In the case that this AudioProcessor is implementing a VST3 that has declared compatible plugins via JUCE_VST3_COMPATIBLE_CLASSES, the state passed to this function may have been created by one of these compatible plugins.

If the parameter IDs of the current plugin differ from the IDs of the plugin whose state was passed to this function, you can use information from the plugin state to determine which parameter mapping to use if necessary. VST3ClientExtensions::getCompatibleParameterIds() will always be called after setStateInformation(), and that function should return the parameter mapping from the most recently-loaded state.

See also
  setCurrentProgramStateInformation, VST3ClientExtensions::getCompatibleParameterIds

Implemented in juce::AudioProcessorGraph::AudioGraphIOProcessor, and juce::AudioProcessorGraph.

References setStateInformation().

Referenced by setStateInformation().

## setCurrentProgramStateInformation()

virtual void juce::AudioProcessor::setCurrentProgramStateInformation | ( | const void * | data,
|  | int | sizeInBytes )

virtual

The host will call this method if it wants to restore the state of just the processor's current program.

Not all hosts support this, and if you don't implement it, the base class method just calls setStateInformation() instead. If you do implement it, be sure to also implement getCurrentProgramStateInformation.

See also
  setStateInformation, getCurrentProgramStateInformation

References setCurrentProgramStateInformation().

Referenced by setCurrentProgramStateInformation().

## numChannelsChanged()

virtual void juce::AudioProcessor::numChannelsChanged | ( |  | ) |

virtual

This method is called when the total number of input or output channels is changed.

References numChannelsChanged().

Referenced by numChannelsChanged().

## numBusesChanged()

virtual void juce::AudioProcessor::numBusesChanged | ( |  | ) |

virtual

This method is called when the number of buses is changed.

References numBusesChanged().

Referenced by numBusesChanged().

## processorLayoutsChanged()

virtual void juce::AudioProcessor::processorLayoutsChanged | ( |  | ) |

virtual

This method is called when the layout of the audio processor changes.

References processorLayoutsChanged().

Referenced by processorLayoutsChanged().

## addListener()

virtual void juce::AudioProcessor::addListener | ( | AudioProcessorListener * | newListener | ) |

virtual

Adds a listener that will be called when an aspect of this processor changes.

References addListener().

Referenced by addListener().

## removeListener()

virtual void juce::AudioProcessor::removeListener | ( | AudioProcessorListener * | listenerToRemove | ) |

virtual

Removes a previously added listener.

References removeListener().

Referenced by removeListener().

## setPlayHead()

virtual void juce::AudioProcessor::setPlayHead | ( | AudioPlayHead * | newPlayHead | ) |

virtual

Tells the processor to use this playhead object.

The processor will not take ownership of the object, so the caller must delete it when it is no longer being used.

References setPlayHead().

Referenced by setPlayHead().

## setPlayConfigDetails()

void juce::AudioProcessor::setPlayConfigDetails | ( | int | numIns,
|  | int | numOuts,
|  | double | sampleRate,
|  | int | blockSize )

This is called by the processor to specify its details before being played.

Use this version of the function if you are not interested in any sidechain and/or aux buses and do not care about the layout of channels. Otherwise use setRateAndBufferSizeDetails.

References setPlayConfigDetails().

Referenced by setPlayConfigDetails().

## setRateAndBufferSizeDetails()

void juce::AudioProcessor::setRateAndBufferSizeDetails | ( | double | sampleRate,
|  | int | blockSize )

noexcept

This is called by the processor to specify its details before being played.

You should call this function after having informed the processor about the channel and bus layouts via setBusesLayout.

See also
  setBusesLayout

References setRateAndBufferSizeDetails().

Referenced by setRateAndBufferSizeDetails().

## audioWorkgroupContextChanged()

virtual void juce::AudioProcessor::audioWorkgroupContextChanged | ( | const AudioWorkgroup & | workgroup | ) |

inline virtual

This is called by the host when the thread workgroup context has changed.

This will only be called on the audio thread, so you can join the audio workgroup in your implementation of this function.

You can use this workgroup id to synchronise any real-time threads you have. Note: This is currently only called on Apple devices.

References audioWorkgroupContextChanged().

Referenced by audioWorkgroupContextChanged().

## getAAXClientExtensions()

virtual AAXClientExtensions & juce::AudioProcessor::getAAXClientExtensions | ( |  | ) |

inline virtual

Returns a reference to an object that implements AAX specific information regarding this AudioProcessor.

## getVST2ClientExtensions()

virtual VST2ClientExtensions * juce::AudioProcessor::getVST2ClientExtensions | ( |  | ) |

virtual

Returns a non-owning pointer to an object that implements VST2 specific information regarding this AudioProcessor.

By default, for backwards compatibility, this will attempt to dynamic-cast this AudioProcessor to VST2ClientExtensions. It is recommended to override this function to return a pointer directly to an object of the correct type in order to avoid this dynamic cast.

## getVST3ClientExtensions()

virtual VST3ClientExtensions * juce::AudioProcessor::getVST3ClientExtensions | ( |  | ) |

virtual

Returns a non-owning pointer to an object that implements VST3 specific information regarding this AudioProcessor.

By default, for backwards compatibility, this will attempt to dynamic-cast this AudioProcessor to VST3ClientExtensions. It is recommended to override this function to return a pointer directly to an object of the correct type in order to avoid this dynamic cast.

## getResponseCurve()

virtual CurveData juce::AudioProcessor::getResponseCurve | ( | CurveData::Type |  | ) | const

inline virtual

## editorBeingDeleted()

void juce::AudioProcessor::editorBeingDeleted | ( | AudioProcessorEditor * |  | ) |

noexcept

Not for public use - this is called before deleting an editor component.

## getWrapperTypeDescription()

const char * juce::AudioProcessor::getWrapperTypeDescription | ( | AudioProcessor::WrapperType |  | ) |

static noexcept

Returns a textual description of a WrapperType value.

## updateTrackProperties()

virtual void juce::AudioProcessor::updateTrackProperties | ( | const TrackProperties & | properties | ) |

virtual

Informs the AudioProcessor that track properties such as the track's name or colour has been changed.

If you are hosting this AudioProcessor then use this method to inform the AudioProcessor about which track the AudioProcessor is loaded on. This method may only be called on the message thread.

If you are implementing an AudioProcessor then you can override this callback to do something useful with the track properties such as changing the colour of your AudioProcessor's editor. It's entirely up to the host when and how often this callback will be called.

The default implementation of this callback will do nothing.

## getNameForMidiNoteNumber()

virtual std::optional< String > juce::AudioProcessor::getNameForMidiNoteNumber | ( | int | note,
|  | int | midiChannel )

virtual

Returns a custom name for a MIDI note number.

This method allows the host to query your plugin for a custom name to display for a given MIDI note number. It's useful for plugins that work with drum kits, microtonal scales, or other mappings.

Parameters

  note | The MIDI note number for which the name is being requested. Some DAWs can request a note range outside of the standard [0-127]. Ensure your plugin can handle this.
  midiChannel | The MIDI channel associated with the note. This is a 1-based index (1-16). Use this parameter if your plugin provides channel-specific note mappings.

## copyXmlToBinary()

void juce::AudioProcessor::copyXmlToBinary | ( | const XmlElement & | xml,
|  | MemoryBlock & | destData )

static

Helper function that just converts an xml element into a binary blob.

Use this in your processor's getStateInformation() method if you want to store its state as xml.

Then use getXmlFromBinary() to reverse this operation and retrieve the XML from a binary blob.

## getXmlFromBinary()

std::unique_ptr< XmlElement > juce::AudioProcessor::getXmlFromBinary | ( | const void * | data,
|  | int | sizeInBytes )

static

Retrieves an XML element that was stored as binary with the copyXmlToBinary() method.

This might return nullptr if the data's unsuitable or corrupted.

## setTypeOfNextNewPlugin()

void JUCE_CALLTYPE juce::AudioProcessor::setTypeOfNextNewPlugin | ( | WrapperType |  | ) |

static

References JUCE_CALLTYPE.

Referenced by juce::createPluginFilterOfType().

## isBusesLayoutSupported()

virtual bool juce::AudioProcessor::isBusesLayoutSupported | ( | const BusesLayout & |  | ) | const

inline protected virtual

Callback to query if the AudioProcessor supports a specific layout.

This callback is called when the host probes the supported bus layouts via the checkBusesLayoutSupported method. You should override this callback if you would like to limit the layouts that your AudioProcessor supports. The default implementation will accept any layout. JUCE does basic sanity checks so that the provided layouts parameter will have the same number of buses as your AudioProcessor.

See also
  checkBusesLayoutSupported

Referenced by canApplyBusesLayout().

## canApplyBusesLayout()

virtual bool juce::AudioProcessor::canApplyBusesLayout | ( | const BusesLayout & | layouts | ) | const

inline protected virtual

Callback to check if a certain bus layout can now be applied.

Most subclasses will not need to override this method and should instead override the isBusesLayoutSupported callback to reject certain layout changes.

This callback is called when the user requests a layout change. It will only be called if processing of the AudioProcessor has been stopped by a previous call to releaseResources or after the construction of the AudioProcessor. It will be called just before the actual layout change. By returning false you will abort the layout change and setBusesLayout will return false indicating that the layout change was not successful.

The default implementation will simply call isBusesLayoutSupported.

You only need to override this method if there is a chance that your AudioProcessor may not accept a layout although you have previously claimed to support it via the isBusesLayoutSupported callback. This can occur if your AudioProcessor's supported layouts depend on other plug-in parameters which may have changed since the last call to isBusesLayoutSupported, such as the format of an audio file which can be selected by the user in the AudioProcessor's editor. This callback gives the AudioProcessor a last chance to reject a layout if conditions have changed as it is always called just before the actual layout change.

As it is never called while the AudioProcessor is processing audio, it can also be used for AudioProcessors which wrap other plug-in formats to apply the current layout to the underlying plug-in. This callback gives such AudioProcessors a chance to reject the layout change should an error occur with the underlying plug-in during the layout change.

See also
  isBusesLayoutSupported, setBusesLayout

References isBusesLayoutSupported().

## applyBusLayouts()

virtual bool juce::AudioProcessor::applyBusLayouts | ( | const BusesLayout & | layouts | ) |

protected virtual

This method will be called when a new bus layout needs to be applied.

Most subclasses will not need to override this method and should just use the default implementation.

## canApplyBusCountChange()

virtual bool juce::AudioProcessor::canApplyBusCountChange | ( | bool | isInput,
|  | bool | isAddingBuses,
|  | BusProperties & | outNewBusProperties )

protected virtual

Callback to query if adding/removing buses currently possible.

This callback is called when the host calls addBus or removeBus. Similar to canApplyBusesLayout, this callback is only called while the AudioProcessor is stopped and gives the processor a last chance to reject a requested bus change. It can also be used to apply the bus count change to an underlying wrapped plug-in.

When adding a bus, isAddingBuses will be true and the plug-in is expected to fill out outNewBusProperties with the properties of the bus which will be created just after the successful return of this callback.

Implementations of AudioProcessor will rarely need to override this method. Only override this method if your processor supports adding and removing buses and if it needs more fine grain control over the naming of new buses or may reject bus number changes although canAddBus or canRemoveBus returned true.

The default implementation will return false if canAddBus/canRemoveBus returns false (the default behavior). Otherwise, this method returns "Input #busIndex" for input buses and "Output #busIndex" for output buses where busIndex is the index for newly created buses. The default layout in this case will be the layout of the previous bus of the same direction.

## Member Data Documentation

## wrapperType

const WrapperType juce::AudioProcessor::wrapperType

When loaded by a plugin wrapper, this flag will be set to indicate the type of plugin within which the processor is running.

## playHead

std::atomic<AudioPlayHead*> juce::AudioProcessor::playHead { nullptr }

protected

Referenced by getPlayHead().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited